require(tree)||stop("Package tree not available. Please install the package")
gap.norm=T
mapability = T
withXY = T
merge.diff= T
quality.merge = T
thresh.diff=0.125
logthresh.diff=0.170
gap.thresh = 1000
LOH.chr = 1:22
forced=T
plotRaw = F
toRedraw = F
plotAI = T
g.setPath = F
dev = 1e-6
window=100
g.appendix = ""
d.appendix = ""
sample.appendix = ""
chr.toScale = array(0, dim=0)
chr.scale = array(0, dim = 0)
toDraw=F
SV.toFilter = F
SV.filter = 3
reDoSV = F
noLogWeight = T
singleBAM = F
single="G"
debug=F
draw=F
Male=F
tm.thresh=0.3
args=(commandArgs(TRUE))
#if (length(args) > 0) for (i in 1:length(args)) eval(parse(text=args[[i]]))
if (length(args) > 0) {
    count = 1
    cont = F
    while (count <= length(args)) {
	if (cont) {
	    s = paste(s, args[[count]])
	} else {
	    s = args[[count]]
	}
	count = count + 1
	res = try(eval(parse(text=s)), silent=T)
	cont = (class(res) == "try-error")
    }
}
if (cont) {
    print("Incomplete parameters. Quit.")
    q()
}
if (tm.thresh < 0) tm.thresh = 0.3
auto.ref = !(exists("norm.chr") | exists("norm.seg") | singleBAM)
is.alter = exists("D.alter")
CREST = exists("crest.cmd")
plotAI = exists("ai.file")

help.fun = function(x) {return(sum(x[7]>bp.chr))}
fun.help = function(mark.tmp, p.thresh) {
	t = try(tree(diff~ChrPos, data=mark.tmp, mindev=dev), silent=T)
	de = dev
	while (class(t) == "try-error") {
	    de = de * 2
	    t = try(tree(diff~ChrPos, data=mark.tmp, mindev=de), silent=T)
	}
	t.p = try(prune.tree(t), silent=T)
	if (class(t.p) == "try-error") {
	    t.p.best = t
	} else {
	    t.p.bic = length(mark.tmp$diff)*log(t.p$dev/length(mark.tmp$diff)) + log(length(mark.tmp$diff)) * (t.p$size + 1)
	    while (which(t.p.bic==min(t.p.bic))[1] == 1 & de > dev/1000) {
		t1 = t
		t1.p = t.p
		de = de / 2
		t = try(tree(diff~ChrPos, data=mark.tmp, mindev=de), silent=T)
		if (class(t) == "try-error") {
		    t = t1
		    t.p = t1.p
		    break
		}
		t.p = prune.tree(t)
		t.p.bic = length(mark.tmp$diff)*log(t.p$dev/length(mark.tmp$diff)) + log(length(mark.tmp$diff)) * (t.p$size + 1)
	    }
	
	    t.p.best = prune.tree(t, best= min(t.p$size[which(t.p.bic==min(t.p.bic, na.rm=T))]))
	}
	
	seg.chr = unique(t.p.best$where)
	for (zz in 1:length(seg.chr)) seg.chr[zz] = sum(t.p.best$where==seg.chr[zz])
	return(seg.chr)
}

fun.chr = function(chr, step=20000, overlap = round(step/20), p.thresh=1e-9, debug=F) {
	mark.chr = cn.D[which(cn.D$SoftChr == chr),]
	chr2 = mark.chr$Chr[1]
	current = 1
	offset = 0
	offset2 = 0
	num.mark1 = -1
	while (current <= nrow(mark.chr)) {
	    if (current + step*1.5 - 1 < nrow(mark.chr)) {
		mark.tmp = mark.chr[current + ((-offset):(step - 1)),]
	 	current = current + step
	    } else {
		mark.tmp = mark.chr[(current - offset):nrow(mark.chr),]
		current = nrow(mark.chr) + 1
	    }
	    mark.seg = fun.help(mark.tmp, p.thresh=p.thresh)
	    if (debug) print(paste("Finsihing", current, "bins.", date()))
	    if (num.mark1[1] < 0) {
		num.mark1 = mark.seg
	    } else {
		mark.seg[1] = mark.seg[1] + offset2
		if (length(num.mark1) > 1) {
		    num.mark1 = c(num.mark1[1:(length(num.mark1) - 1)], mark.seg)
		} else {
		    num.mark1 = mark.seg
		}
	    }
	    if (num.mark1[length(num.mark1)] > overlap) {
		offset = overlap
	    } else {
		offset = num.mark1[length(num.mark1)]
	    }
	    offset2 = num.mark1[length(num.mark1)] - offset

	}

	Start = array(1, dim=length(num.mark1))
	if (length(Start) > 1) {
	    for (i in 2 : length(num.mark1)) Start[i] = Start[i - 1] + num.mark1[i - 1]
	    p.val = array(1, length(num.mark1)-1)
	    for (i in 1: length(p.val))
	    	p.val[i] = t.test(mark.chr$diff[Start[i]:(Start[i] + num.mark1[i] - 1)], mark.chr$diff[Start[i + 1]:(Start[i + 1] + num.mark1[i + 1] - 1)])$p.value
	    p.max.id = which(p.val == max(p.val))[1]
	    while (max(p.val) > p.thresh) {
	    	num.mark1[p.max.id] = num.mark1[p.max.id] + num.mark1[p.max.id+1]
		num.mark1 = num.mark1[-(p.max.id + 1)]
	    	p.val = p.val[-p.max.id]
	    	Start = Start[-(p.max.id+1)]
	    	if (p.max.id > 1)
		    p.val[p.max.id-1] = t.test(mark.chr$diff[Start[p.max.id-1]:(num.mark1[p.max.id - 1] + Start[p.max.id-1] - 1)], mark.chr$diff[Start[p.max.id]:(num.mark1[p.max.id] + Start[p.max.id] - 1)])$p.value
	    	if (p.max.id <= length(p.val))
		    p.val[p.max.id] = t.test(mark.chr$diff[Start[p.max.id]:(num.mark1[p.max.id] + Start[p.max.id] - 1)], mark.chr$diff[Start[p.max.id+1]:(num.mark1[p.max.id+1] + Start[p.max.id+1] - 1)])$p.value
	    	p.max.id = which(p.val == max(p.val))[1]
	    }
	}
	current = 1
	offset = 0
	offset2 = 0
	num.mark2 = -1
	while (current <= nrow(mark.chr)) {
	    if 	(current + step*1.5 - 1 < nrow(mark.chr)) {
		mark.tmp = mark.chr[current + ((-offset):(step - 1)),]
	 	current = current + step
	    } else {
		mark.tmp = mark.chr[(current - offset):nrow(mark.chr),]
		current = nrow(mark.chr) + 1
	    }
	    mark.tmp$diff = mark.tmp$Log
	    mark.seg = fun.help(mark.tmp, p.thresh=p.thresh)
	    if (debug) print(paste("Pahse 2, Finsihing", current, "bins.", date()))

	    if (num.mark2[1] < 0) {
		num.mark2 = mark.seg
	    } else {
		mark.seg[1] = mark.seg[1] + offset2
		if (length(num.mark2) > 1) {
		    num.mark2 = c(num.mark2[1:(length(num.mark2) - 1)], mark.seg)
		} else {
		    num.mark2 = mark.seg
		}
	    }
	    if (num.mark2[length(num.mark2)] > overlap) {
		offset = overlap
	    } else {
		offset = num.mark2[length(num.mark2)]
	    }
	    #print(sum(num.mark))
	}
	Start = array(1, dim=length(num.mark2))
	if (length(Start) > 1) {
	    for (i in 2 : length(num.mark2)) Start[i] = Start[i - 1] + num.mark2[i - 1]
	    p.val = array(1, length(num.mark2)-1)
	    for (i in 1: length(p.val))
	    	p.val[i] = t.test(mark.chr$Log[Start[i]:(Start[i] + num.mark2[i] - 1)], mark.chr$Log[Start[i + 1]:(Start[i + 1] + num.mark2[i + 1] - 1)])$p.value
	    p.max.id = which(p.val == max(p.val))[1]
	    while (max(p.val) > p.thresh) {
	    	num.mark2[p.max.id] = num.mark2[p.max.id] + num.mark2[p.max.id+1]
		num.mark2 = num.mark2[-(p.max.id + 1)]
	    	p.val = p.val[-p.max.id]
	    	Start = Start[-(p.max.id+1)]
	    	if (p.max.id > 1)
		    p.val[p.max.id-1] = t.test(mark.chr$Log[Start[p.max.id-1]:(num.mark2[p.max.id - 1] + Start[p.max.id-1] - 1)], mark.chr$Log[Start[p.max.id]:(num.mark2[p.max.id] + Start[p.max.id] - 1)])$p.value
	    	if (p.max.id <= length(p.val))
		    p.val[p.max.id] = t.test(mark.chr$Log[Start[p.max.id]:(num.mark2[p.max.id] + Start[p.max.id] - 1)], mark.chr$Log[Start[p.max.id+1]:(num.mark2[p.max.id+1] + Start[p.max.id+1] - 1)])$p.value
	    	p.max.id = which(p.val == max(p.val))[1]
	    }
	}

	n1 = 1
	n2 = 1
	n3 = 1
	num.mark = array(0, length(c(num.mark1, num.mark2)))
	l1 = num.mark1[1]
	l2 = num.mark2[1]
	while ((n1 <= length(num.mark1)) & (n2 <= length(num.mark2))) {
	    if (l1 <= l2) {
		num.mark[n3] = l1
		l2 = l2 - l1
		l1 = 0
	    } else {
		num.mark[n3] = l2
		l1 = l1 - l2
		l2 = 0
	    }
	    if (l1 == 0) {
		n1 = n1 + 1
		if (n1 <= length(num.mark1)) l1 = num.mark1[n1]
	    }
	    if (l2 == 0) {
		n2 = n2 + 1
		if (n2 <= length(num.mark2)) l2 = num.mark2[n2]
	    }
	    n3 = n3 + 1
	}
	if (n1 < length(num.mark1)) {
	    if (l1 > 0) {
		num.mark[n3] = l1
		n3 = n3 + 1
		n1 = n1 + 1
	    }
	    while (n1 <= length(num.mark1)) {
		num.mark[n3] = num.mark1[n1]
		n3 = n3 + 1
		n1 = n1 + 1
	    }
	} else if (n2 < length(num.mark2)) {
	    if (l2 > 0) {
		num.mark[n3] = l2
		n3 = n3 + 1
		n2 = n2 + 1
	    }
	    while (n2 <= length(num.mark2)) {
		num.mark[n3] = num.mark2[n2]
		n3 = n3 + 1
		n2 = n2 + 1
	    }
	} else {
	    if (l1 > 0) {
		num.mark[n3] = l1
		n3 = n3 + 1
	    }
	    if (l2 > 0) {
		num.mark[n3] = l2
		n3 = n3 + 1
	    }
	}
	num.mark = (num.mark[1:(n3-1)])
	seg.chr =  data.frame(matrix(0, nrow=length(num.mark), ncol=9, dimnames = list(NULL, c("chrom", "loc.start", "loc.end", "num.mark", "length.ratio", "seg.mean", "GMean", "DMean", "LogRatio"))))
	seg.chr$num.mark = num.mark
	seg.chr$chrom = chr2
	Start = array(1, dim=nrow(seg.chr))
	if (nrow(seg.chr) > 1) {
	    for (i in 2 : nrow(seg.chr)) Start[i] = Start[i - 1] + seg.chr$num.mark[i - 1]
	}
	seg.chr$loc.start = mark.chr$ChrPos[Start] - 49
	seg.chr$loc.end = mark.chr$ChrPos[Start + seg.chr$num.mark - 1] + 50
	seg.chr$GMean = Start
	seg.chr$DMean = Start
	for (j in 1:length(Start)) {
	    seg.chr$seg.mean[j] = mean(mark.chr$diff[Start[j]:(Start[j] + seg.chr$num.mark[j] - 1)], na.rm=T)
	    seg.chr$LogRatio[j] = mean(mark.chr$Log[Start[j]:(Start[j] + seg.chr$num.mark[j] - 1)], na.rm=T)
	    seg.chr$GMean[j] = mean(mark.chr$GMean[Start[j]:(Start[j] + seg.chr$num.mark[j] - 1)], na.rm=T)
	    seg.chr$DMean[j] = mean(mark.chr$Mean[Start[j]:(Start[j] + seg.chr$num.mark[j] - 1)], na.rm=T)
	}

	seg.diff = abs(seg.chr$seg.mean[-nrow(seg.chr)] - seg.chr$seg.mean[-1])
	seg.diff.id = which(seg.diff == min(seg.diff))[1]
	while (min(seg.diff) < thresh.diff) {
	    seg.chr$seg.mean[seg.diff.id] = (seg.chr$seg.mean[seg.diff.id] * seg.chr$num.mark[seg.diff.id] + seg.chr$seg.mean[seg.diff.id+1] * seg.chr$num.mark[seg.diff.id+1])/(seg.chr$num.mark[seg.diff.id] + seg.chr$num.mark[seg.diff.id+1])
	    seg.chr$GMean[seg.diff.id] = (seg.chr$GMean[seg.diff.id] * seg.chr$num.mark[seg.diff.id] + seg.chr$GMean[seg.diff.id+1] * seg.chr$num.mark[seg.diff.id+1])/(seg.chr$num.mark[seg.diff.id] + seg.chr$num.mark[seg.diff.id+1])
	    seg.chr$DMean[seg.diff.id] = (seg.chr$DMean[seg.diff.id] * seg.chr$num.mark[seg.diff.id] + seg.chr$DMean[seg.diff.id+1] * seg.chr$num.mark[seg.diff.id+1])/(seg.chr$num.mark[seg.diff.id] + seg.chr$num.mark[seg.diff.id+1])
	    seg.chr$LogRatio[seg.diff.id] = (seg.chr$LogRatio[seg.diff.id] * seg.chr$num.mark[seg.diff.id] + seg.chr$LogRatio[seg.diff.id+1] * seg.chr$num.mark[seg.diff.id+1])/(seg.chr$num.mark[seg.diff.id] + seg.chr$num.mark[seg.diff.id+1])
	    seg.chr$num.mark[seg.diff.id] = seg.chr$num.mark[seg.diff.id] + seg.chr$num.mark[seg.diff.id+1]
	    seg.chr$loc.end[seg.diff.id] = seg.chr$loc.end[seg.diff.id + 1]
	    seg.chr = seg.chr[-(seg.diff.id + 1),]
	    seg.diff = seg.diff[-seg.diff.id]
	    if (seg.diff.id > 1)
		seg.diff[seg.diff.id-1] = abs(seg.chr$seg.mean[seg.diff.id] - seg.chr$seg.mean[seg.diff.id-1])
	    if (seg.diff.id <= length(seg.diff))
		seg.diff[seg.diff.id] = abs(seg.chr$seg.mean[seg.diff.id+1] - seg.chr$seg.mean[seg.diff.id])
	    seg.diff.id = which(seg.diff == min(seg.diff))[1]
	}

	seg.diff = abs(seg.chr$LogRatio[-nrow(seg.chr)] - seg.chr$LogRatio[-1])
	seg.diff.id = which(seg.diff == min(seg.diff))[1]
	while (min(seg.diff) < logthresh.diff) {
	    seg.chr$seg.mean[seg.diff.id] = (seg.chr$seg.mean[seg.diff.id] * seg.chr$num.mark[seg.diff.id] + seg.chr$seg.mean[seg.diff.id+1] * seg.chr$num.mark[seg.diff.id+1])/(seg.chr$num.mark[seg.diff.id] + seg.chr$num.mark[seg.diff.id+1])
	    seg.chr$GMean[seg.diff.id] = (seg.chr$GMean[seg.diff.id] * seg.chr$num.mark[seg.diff.id] + seg.chr$GMean[seg.diff.id+1] * seg.chr$num.mark[seg.diff.id+1])/(seg.chr$num.mark[seg.diff.id] + seg.chr$num.mark[seg.diff.id+1])
	    seg.chr$DMean[seg.diff.id] = (seg.chr$DMean[seg.diff.id] * seg.chr$num.mark[seg.diff.id] + seg.chr$DMean[seg.diff.id+1] * seg.chr$num.mark[seg.diff.id+1])/(seg.chr$num.mark[seg.diff.id] + seg.chr$num.mark[seg.diff.id+1])
	    seg.chr$LogRatio[seg.diff.id] = (seg.chr$LogRatio[seg.diff.id] * seg.chr$num.mark[seg.diff.id] + seg.chr$LogRatio[seg.diff.id+1] * seg.chr$num.mark[seg.diff.id+1])/(seg.chr$num.mark[seg.diff.id] + seg.chr$num.mark[seg.diff.id+1])
	    seg.chr$num.mark[seg.diff.id] = seg.chr$num.mark[seg.diff.id] + seg.chr$num.mark[seg.diff.id+1]
	    seg.chr$loc.end[seg.diff.id] = seg.chr$loc.end[seg.diff.id + 1]
	    seg.chr = seg.chr[-(seg.diff.id + 1),]
	    seg.diff = seg.diff[-seg.diff.id]
	    if (seg.diff.id > 1)
		seg.diff[seg.diff.id-1] = abs(seg.chr$LogRatio[seg.diff.id] - seg.chr$LogRatio[seg.diff.id-1])
	    if (seg.diff.id <= length(seg.diff))
		seg.diff[seg.diff.id] = abs(seg.chr$LogRatio[seg.diff.id+1] - seg.chr$LogRatio[seg.diff.id])
	    seg.diff.id = which(seg.diff == min(seg.diff))[1]
	}

	seg.chr$length.ratio = seg.chr$num.mark * 100 / (seg.chr$loc.end - seg.chr$loc.start + 1)
	return(seg.chr)
}

fun.chr.germline = function(chr, step=20000, overlap = round(step/20), p.thresh=1e-9, debug=F) {
	mark.chr = cn.D[which(cn.D$SoftChr == chr),]
	chr2 = mark.chr$Chr[1]
	current = 1
	offset = 0
	offset2 = 0
	num.mark1 = -1
	while (current <= nrow(mark.chr)) {
	    if (current + step*1.5 - 1 < nrow(mark.chr)) {
		mark.tmp = mark.chr[current + ((-offset):(step - 1)),]
	 	current = current + step
	    } else {
		mark.tmp = mark.chr[(current - offset):nrow(mark.chr),]
		current = nrow(mark.chr) + 1
	    }
	    mark.seg = fun.help(mark.tmp, p.thresh=p.thresh)
	    if (debug) print(paste("Finsihing", current, "bins.", date()))
	    if (num.mark1[1] < 0) {
		num.mark1 = mark.seg
	    } else {
		mark.seg[1] = mark.seg[1] + offset2
		if (length(num.mark1) > 1) {
		    num.mark1 = c(num.mark1[1:(length(num.mark1) - 1)], mark.seg)
		} else {
		    num.mark1 = mark.seg
		}
	    }
	    if (num.mark1[length(num.mark1)] > overlap) {
		offset = overlap
	    } else {
		offset = num.mark1[length(num.mark1)]
	    }
	    offset2 = num.mark1[length(num.mark1)] - offset

	}

	Start = array(1, dim=length(num.mark1))
	if (length(Start) > 1) {
	    for (i in 2 : length(num.mark1)) Start[i] = Start[i - 1] + num.mark1[i - 1]
	    p.val = array(1, length(num.mark1)-1)
	    for (i in 1: length(p.val))
	    	p.val[i] = t.test(mark.chr$diff[Start[i]:(Start[i] + num.mark1[i] - 1)], mark.chr$diff[Start[i + 1]:(Start[i + 1] + num.mark1[i + 1] - 1)])$p.value
	    p.max.id = which(p.val == max(p.val))[1]
	    while (max(p.val) > p.thresh) {
	    	num.mark1[p.max.id] = num.mark1[p.max.id] + num.mark1[p.max.id+1]
		num.mark1 = num.mark1[-(p.max.id + 1)]
	    	p.val = p.val[-p.max.id]
	    	Start = Start[-(p.max.id+1)]
	    	if (p.max.id > 1)
		    p.val[p.max.id-1] = t.test(mark.chr$diff[Start[p.max.id-1]:(num.mark1[p.max.id - 1] + Start[p.max.id-1] - 1)], mark.chr$diff[Start[p.max.id]:(num.mark1[p.max.id] + Start[p.max.id] - 1)])$p.value
	    	if (p.max.id <= length(p.val))
		    p.val[p.max.id] = t.test(mark.chr$diff[Start[p.max.id]:(num.mark1[p.max.id] + Start[p.max.id] - 1)], mark.chr$diff[Start[p.max.id+1]:(num.mark1[p.max.id+1] + Start[p.max.id+1] - 1)])$p.value
	    	p.max.id = which(p.val == max(p.val))[1]
	    }
	}
	num.mark = num.mark1
	seg.chr =  data.frame(matrix(0, nrow=length(num.mark), ncol=6, dimnames = list(NULL, c("chrom", "loc.start", "loc.end", "num.mark", "length.ratio", "seg.mean"))))
	seg.chr$num.mark = num.mark
	seg.chr$chrom = chr2
	Start = array(1, dim=nrow(seg.chr))
	if (nrow(seg.chr) > 1) {
	    for (i in 2 : nrow(seg.chr)) Start[i] = Start[i - 1] + seg.chr$num.mark[i - 1]
	}
	seg.chr$loc.start = mark.chr$ChrPos[Start] - 49
	seg.chr$loc.end = mark.chr$ChrPos[Start + seg.chr$num.mark - 1] + 50
	for (j in 1:length(Start)) {
	    seg.chr$seg.mean[j] = mean(mark.chr$diff[Start[j]:(Start[j] + seg.chr$num.mark[j] - 1)], na.rm=T)
	}

	seg.diff = abs(seg.chr$seg.mean[-nrow(seg.chr)] - seg.chr$seg.mean[-1])
	seg.diff.id = which(seg.diff == min(seg.diff))[1]
	while (min(seg.diff) < thresh.diff) {
	    seg.chr$seg.mean[seg.diff.id] = (seg.chr$seg.mean[seg.diff.id] * seg.chr$num.mark[seg.diff.id] + seg.chr$seg.mean[seg.diff.id+1] * seg.chr$num.mark[seg.diff.id+1])/(seg.chr$num.mark[seg.diff.id] + seg.chr$num.mark[seg.diff.id+1])
	    seg.chr$num.mark[seg.diff.id] = seg.chr$num.mark[seg.diff.id] + seg.chr$num.mark[seg.diff.id+1]
	    seg.chr$loc.end[seg.diff.id] = seg.chr$loc.end[seg.diff.id + 1]
	    seg.chr = seg.chr[-(seg.diff.id + 1),]
	    seg.diff = seg.diff[-seg.diff.id]
	    if (seg.diff.id > 1)
		seg.diff[seg.diff.id-1] = abs(seg.chr$seg.mean[seg.diff.id] - seg.chr$seg.mean[seg.diff.id-1])
	    if (seg.diff.id <= length(seg.diff))
		seg.diff[seg.diff.id] = abs(seg.chr$seg.mean[seg.diff.id+1] - seg.chr$seg.mean[seg.diff.id])
	    seg.diff.id = which(seg.diff == min(seg.diff))[1]
	}

	seg.chr$length.ratio = seg.chr$num.mark * 100 / (seg.chr$loc.end - seg.chr$loc.start + 1)
	return(seg.chr)
}


findRegion = function(chr, pos) {
    region = c(-1,-1)
    if (sum(done[,1] == chr & done[,2] <= (pos - 10000) & done[,3] >= (pos - 10000)) == 0) {
	region[1] = pos - 10000
    } else {
	region[1] = max(done[which(done[,1] == chr & done[,2] <= (pos - 10000) & done[,3] >= (pos - 10000)), 3] + 1)
    }
    if (region[1] < 1) region[1] = 1
    if (sum(done[,1] == chr & done[,2] <= (pos + 10000) & done[,3] >= (pos + 10000)) == 0) {
	region[2] = pos + 10000
    } else {
	region[2] = min(done[which(done[,1] == chr & done[,2] <= (pos + 10000) & done[,3] >= (pos + 10000)), 2] - 1)
    }
    return(region)
}




sample
window
singleBAM
if (exists("norm.chr")) print(norm.chr)
if (exists("norm.seg")) print(norm.seg)
if (exists("est.D")) print(est.D)
setwd(wd)
if (!file.exists("Result")) dir.create("Result")
paste("Starting time:", date())
if (is.alter) {
    file.name = paste(sample,"_", D.alter, d.appendix, "_chr",1, "_", window,sep="")
} else if (singleBAM){
    file.name = paste(sample,"_", single, d.appendix, "_chr",1, "_", window,sep="")
} else {
    file.name = paste(sample,"_D", d.appendix, "_chr",1, "_", window,sep="")
}
if (!file.exists(file.name)) {
    print("No input file, quit.")
    q()
}
if (CREST) {
    if (!is.alter) {
	file.name = paste(sample,".SV.lst", sep="")
    } else {
	file.name = paste(sample,D.alter,".SV.lst",sep="")
    }
    if (!file.exists(file.name)) {
	print("No initial SV input file, quit.")
	q()
    }
} else {
    quality.merge=F
}
if (singleBAM) quality.merge=F
if (length(chr.toScale) != length(chr.scale)) {
    print("The length of chr.toScale and chr.scale is different, quit.")
    q()
}
if (CREST) {
    sv.file = paste(sample,".SV.lst", sep="")
    if (is.alter) sv.file = paste(sample,D.alter,".SV.lst", sep="")


    bp = try(read.table(sv.file))
    if (class(bp) == "try-error") {
	bp = NULL
    } else {
	if (ncol(bp) > 6) bp = bp[,c(1:3,5:7)]
	bp =  rbind(as.matrix(bp[,1:2]), as.matrix(bp[,4:5]))
    }
    print(dim(bp))

    file.crest = paste("Result/test",d.appendix,sep="")
    if (is.alter) file.crest = paste(file.crest, D.alter, sep="")
    if (mapability) file.crest = paste(file.crest, "-map", sep="")
    if (singleBAM) file.crest = paste(file.crest, "-single", single, sep="")
    crest.cmd = paste(crest.cmd, " -max_rep_cover 2000 -min_hit_len 15 -p ", file.crest, " -min_percent_hq 40 -m 1 -min_one_side_reads 2 -r ", sep="")
}
if (plotAI) {
    if (!file.exists(ai.file)) plotAI=F}
if (plotAI) {
    ai = read.table(ai.file, header=T)
    if (is.alter) {
	file.name = paste("Result/", sample, D.alter, "_LOH_RegTree.txt", sep="")
    } else {
	file.name = paste("Result/", sample, "_LOH_RegTree.txt", sep="")
    }
    if (!file.exists(file.name)) {
	num.test = 0
	offset = array(0, 23)
	for (i in 1:22) {
	    num.mark = sum(ai$Chromosome==i) - sum(is.nan(ai$AI[which(ai$Chromosome==i)]))
	    num.test = num.test + num.mark^3/6 - num.mark^2/2 + num.mark/3
	    offset[i + 1] = offset[i] + max(ai$Position[which(ai$Chromosome==i)])
	}
	p.thresh = 0.05 / num.test
	step = 20000
	overlap = step/20
	for (i in 1:22) {
	    mark.chr = ai[which(ai$Chromosome == i & (!is.na(ai$AI))),]
	    colnames(mark.chr) = list("Chr", "ChrPos", "diff")
	    current = 1
	    offset = 0
	    offset2 = 0
	    num.mark = -1
	    while (current <= nrow(mark.chr)) {
		if (current + step*1.5 - 1 < nrow(mark.chr)) {
		    mark.tmp = mark.chr[current + ((-offset):(step - 1)),]
	 	    current = current + step
		} else {
		    mark.tmp = mark.chr[(current - offset):length(mark.chr$diff),]
		    current = nrow(mark.chr) + 1
		}
		mark.seg = fun.help(mark.tmp, p.thresh=p.thresh)
		if (num.mark[1] < 0) {
		    num.mark = mark.seg
		} else {
		    mark.seg[1] = mark.seg[1] + offset2
		    if (length(num.mark) > 1) {
			num.mark = c(num.mark[1:(length(num.mark) - 1)], mark.seg)
		    } else {
			num.mark = mark.seg
		    }
		}
		if (num.mark[length(num.mark)] > overlap) {
		    offset = overlap
		} else {
		    offset = num.mark[length(num.mark)]
		}
		offset2 = num.mark[length(num.mark)] - offset
	    }
	    Start = array(1, dim=length(num.mark))
	    if (length(Start) > 1) {
		for (j in 2 : length(num.mark)) Start[j] = Start[j - 1] + num.mark[j - 1]
		p.val = array(1, length(num.mark)-1)
		for (j in 1: length(p.val))
	    	    p.val[j] = t.test(mark.chr$diff[Start[j]:(Start[j] + num.mark[j] - 1)], mark.chr$diff[Start[j + 1]:(Start[j + 1] + num.mark[j + 1] - 1)])$p.value
		p.max.id = which(p.val == max(p.val))[1]
		while (max(p.val) > p.thresh) {
	    	    num.mark[p.max.id] = num.mark[p.max.id] + num.mark[p.max.id+1]
		    num.mark = num.mark[-(p.max.id + 1)]
		    p.val = p.val[-p.max.id]
	    	    Start = Start[-(p.max.id+1)]
	    	    if (p.max.id > 1)
			p.val[p.max.id-1] = t.test(mark.chr$diff[Start[p.max.id-1]:(num.mark[p.max.id - 1] + Start[p.max.id-1] - 1)], mark.chr$diff[Start[p.max.id]:(num.mark[p.max.id] + Start[p.max.id] - 1)])$p.value
	    	    if (p.max.id <= length(p.val))
			p.val[p.max.id] = t.test(mark.chr$diff[Start[p.max.id]:(num.mark[p.max.id] + Start[p.max.id] - 1)], mark.chr$diff[Start[p.max.id+1]:(num.mark[p.max.id+1] + Start[p.max.id+1] - 1)])$p.value
	    	    p.max.id = which(p.val == max(p.val))[1]
		}
	    }
	    seg.chr =  data.frame(matrix(0, nrow=length(num.mark), ncol=5, dimnames = list(NULL, c("chrom", "loc.start", "loc.end", "num.mark", "seg.mean"))))
	    seg.chr$num.mark = num.mark
	    seg.chr$chrom = i
	    Start = array(1, dim=nrow(seg.chr))
	    if (nrow(seg.chr) > 1) {
		for (j in 2 : nrow(seg.chr)) Start[j] = Start[j - 1] + seg.chr$num.mark[j - 1]
	    }
	    seg.chr$loc.start = mark.chr$ChrPos[Start]
	    seg.chr$loc.end = mark.chr$ChrPos[Start + num.mark - 1]
	    for (j in 1 : length(Start)) {
		seg.chr$seg.mean[j] = mean(mark.chr$diff[Start[j]:(Start[j] + seg.chr$num.mark[j] - 1)], na.rm=T)
	    }
	    if (i ==1) {
		seg.final = seg.chr
	    } else {
		seg.final = rbind(seg.final, seg.chr)
	    }
	}
	write.table(seg.final, file.name, col.names=TRUE,row.names=FALSE,sep="\t",quote=FALSE)
    }
}
numChr = 22
if (withXY) numChr = 24
offset = array(0, numChr + 1)
norm.all=F
if (auto.ref) {
    if (is.alter) {
	file.name = paste("Result/", sample, D.alter, "_LOH_RegTree.txt", sep="")
    } else {
	file.name = paste("Result/", sample, "_LOH_RegTree.txt", sep="")
    }
    loh = try(read.table(file.name, header=T), silent=T)
    if (class(loh) == "try-error") {
	auto.ref=F
	norm.all = T
    } else {
	id = which(loh$seg.mean < 0.1 & (loh$loc.end - loh$loc.start >= 1e6))
	if (length(id) == 0) {
	    auto.ref=F
	} else {
	    loh = loh[id,]
	    print(loh)
	}
    }
}  else {
    if (exists("norm.chr")) norm.all = (length(norm.chr) == numChr)
}
softChr = 1
for (chr in 1 : numChr) {
    if (chr < 23) {
     	gc = read.table(paste(gc.prefix, chr, "_", window,".txt", sep=""), header=T)
	if (CREST) bp.chr = sort(unique(as.integer(bp[which(bp[,1]==chr),2])))
    }
    if (chr == 23) {
	gc = read.table(paste(gc.prefix, "X_", window,".txt", sep=""), header=T)
	if (CREST) bp.chr = sort(unique(as.integer(bp[which(bp[,1]=="X"),2])))
    }
    if (chr == 24) {
	gc = read.table(paste(gc.prefix, "Y_", window,".txt", sep=""), header=T)
	if (CREST) bp.chr = sort(unique(as.integer(bp[which(bp[,1]=="Y"),2])))
    }
    if (is.alter) {
	file.name<-paste(sample,"_", D.alter, d.appendix, "_chr",chr, "_", window,sep="")
    } else {
	file.name<-paste(sample,"_D", d.appendix, "_chr",chr, "_", window,sep="")
    }
    if (singleBAM) {
	file.name<-paste(sample,"_", single, d.appendix, "_chr",chr, "_", window,sep="")
    }
    chr.D =  try(read.table(file.name, header=T))
    if (class(chr.D) == "try-error") {
	print(paste("Error in reading", file.name))
	q()
    }
    if (nrow(chr.D) == 0) {
	softChr = softChr + 1
	next
    }
    chr.D$Position = chr.D$Position + offset[chr]
    chr.D$N = gc$N
    chr.D$ChrPos = chr.D$Position - offset[chr]
    chr.D$Chr = chr
    chr.D$Map = scan(paste(map.prefix, "Mapability_chr", chr, "_", window,  sep=""))
    chr.D$SoftChr = softChr
    if (CREST) {
	if (length(bp.chr) > 0) {
	    chr.D$SoftChr = softChr + apply(chr.D, 1, help.fun)
	    softChr = max(chr.D$SoftChr) + 1
	} else {
	    softChr = softChr + 1
	}
    } else {
	softChr = softChr + 1
    }
    if (!singleBAM) {
	if (!g.setPath) {
	    file.name<-paste(sample,"_G_chr",chr, "_", window,sep="")
	} else {
	    file.name = paste(g.path,sample,"_G_chr",chr, "_", window,sep="")
	}
	chr.G =  try(read.table(file.name, header=T))
	if (class(chr.G) == "try-error") {
	    print(paste("Error in reading", file.name))
	    q()
	}
	chr.D$GMean = chr.G$Mean
	chr.D$Log = log2((chr.D$Mean + 0.01) / (chr.G$Mean + 0.01))
	chr.D$GSD = chr.G$SD
	chr.D$GOutliers = chr.G$Outliers 
    }
    chr.D$GC = gc$GC
    offset[chr + 1] = offset[chr] + nrow(chr.D) * window
    if (!exists("cn.D")) {
	cn.D = chr.D
    } else {
	cn.D[nrow(cn.D) + (1:nrow(chr.D)),] = chr.D
    }
    if (auto.ref) {
	id = which(loh$chrom == chr)
	if (length(id) > 0) {
	    for (i in 1:length(id)) {
		id2 = (chr.D$ChrPos >= loh$loc.start[id[i]] & chr.D$ChrPos <= loh$loc.end[id[i]])
		if (length(id2) > 0) {
		    cont = T
		    if (exists("est.D")) {
			if (median(chr.D$Mean[id2], na.rm=T) < est.D * 1.25) cont =F
		    }
		    if (cont) {
			if (!exists("norm.D")) {
			    norm.D = chr.D[id2,]
			} else {
			    norm.D[nrow(norm.D) + (1 : sum(id2)),] = chr.D[id2,]
			}
		    }
		}
	    }
	} 
    } else if (!norm.all) {
	if (exists("norm.seg")) {
	    if (chr == norm.seg[1]) {
		norm.D = chr.D[which(chr.D$ChrPos > norm.seg[2] & chr.D$ChrPos <= norm.seg[3]),]
	    }
	} else {
	    if (chr == norm.chr[1]) {
	    	norm.D = chr.D
	    } else {
	    	if (sum(chr == norm.chr) > 0) {
		    norm.D[nrow(norm.D) + (1:nrow(chr.D)),] = chr.D
	    	}
	    }
	}
    }
    rm(chr.D)
    if (!singleBAM) rm(chr.G)
    rm(gc)
    print(paste(chr, softChr - 1, date()))
    if (debug | chr==5 | chr==13) print(gc(debug))
}
cn.orig=cn.D[,c(1,6)]
file.name = ""
paste("Finishing reading genome data:", date())
if (norm.all) {
     m1 = median(cn.D$Mean, na.rm=T)
     cn.D$Mean = cn.D$Mean / m1
     cn.D$SD = cn.D$SD / m1
     if (!singleBAM) {
	m2 = median(cn.D$GMean, na.rm=T)
	cn.D$GMean = cn.D$GMean / m2
	cn.D$Log = cn.D$Log - median(cn.D$Log, na.rm=T)
	cn.D$GSD = cn.D$GSD / m2
     }
} else {
     if (auto.ref) {
	m1 = median(norm.D$Mean, na.rm=T)
       norm.D = norm.D[which(norm.D$Mean <= 1.25 * m1),] #To remove the potential balanced duplication
     }
     m1 = median(norm.D$Mean, na.rm=T)
     cn.D$Mean = cn.D$Mean / median(norm.D$Mean, na.rm=T)
     cn.D$SD = cn.D$SD / m1
     norm.D$Mean = norm.D$Mean / median(norm.D$Mean, na.rm=T)
     norm.D$SD = norm.D$SD / m1
     if (!singleBAM) {
     	m2 = median(norm.D$GMean, na.rm=T)
     	cn.D$GMean = cn.D$GMean / median(norm.D$GMean, na.rm=T)
     	cn.D$Log = cn.D$Log - median(norm.D$Log, na.rm=T)
     	cn.D$GSD = cn.D$GSD / m2
     	norm.D$GMean = norm.D$GMean / median(norm.D$GMean, na.rm=T)
     	norm.D$Log = norm.D$Log - median(norm.D$Log, na.rm=T)
     	norm.D$GSD = norm.D$GSD / m2
     }
}
if (!singleBAM) {
    cn.D$diff = cn.D$Mean - cn.D$GMean
} else {
    cn.D$diff = cn.D$Mean
}
if (mapability) {
    rm.idx = unique(c(which(cn.D$Map < 0.9), which(is.na(cn.D$GC))))
    if (norm.all) {
	    weight = 1 / (cn.D$SD^2 + 0.01)
    } else {
	    weight = 1 / (norm.D$SD^2 + 0.01)
    }
} else {
  if (gap.norm) {
    if (singleBAM) {
	rm.tmp = unique(c(which(cn.D$N > 0.5), which(cn.D$Outliers > window / 20)))
    } else {
	rm.tmp = unique(c(which(cn.D$N > 0.5), which(cn.D$Outliers > window / 20), which(cn.D$GOutliers > window / 20)))
    }
    count = 1
    gap.start = rm.tmp[1]
    current.len = 1
    while (count < length(rm.tmp)) {
	if (rm.tmp[count + 1] - rm.tmp[count] == 1 & (count < length(rm.tmp) - 1)) {
	    if (current.len < gap.thresh) current.len = current.len + 1
	} else {
	    if (gap.start == rm.tmp[1]) {
		rm.idx = max(1, gap.start - current.len) : min(rm.tmp[count] + current.len, nrow(cn.D))
	    } else {
		rm.idx = c(rm.idx, max(1, gap.start - current.len) : min(rm.tmp[count] + current.len, nrow(cn.D)))
	    }
	    gap.start = rm.tmp[count + 1]
	    current.len = 1
	}
	count = count + 1
    }
    rm.idx = unique(rm.idx)
    if (norm.all) {
	    weight = 1 / (cn.D$SD^2 + 0.01)
    } else {
	    weight = 1 / (norm.D$SD^2 + 0.01)
    }
  } else {
    if (singleBAM) {
	rm.idx = unique(c(which(cn.D$N > 0.5), which(cn.D$Outliers > window / 20), which(cn.D$Mean>4)))
    } else {
	rm.idx = unique(c(which(cn.D$N > 0.5), which(cn.D$Outliers > window / 20), which(cn.D$GOutliers > window / 20), which(cn.D$Mean>8), which(cn.D$GMean>4)))
    }
  }
}
if (!norm.all) {
  if (mapability) {
    rm.idx2 = unique(c(which(norm.D$Map < 0.9), which(is.na(norm.D$GC))))
  } else {
    if (gap.norm) {
	if (singleBAM) {
	    rm.tmp = unique(c(which(norm.D$N > 0.5), which(norm.D$Outliers > window / 20)))
	} else {
	    rm.tmp = unique(c(which(norm.D$N > 0.5), which(norm.D$Outliers > window / 20), which(norm.D$GOutliers > window / 20), which(norm.D$Mean==0 & norm.D$GMean==0)))
	}
    	count = 1
    	gap.start = rm.tmp[1]
    	current.len = 1
    	while (count < length(rm.tmp)) {
	    if (rm.tmp[count + 1] - rm.tmp[count] == 1 & (count < length(rm.tmp) - 1)) {
	    	if (current.len < gap.thresh) current.len = current.len + 1
	    } else {
	    	if (gap.start == rm.tmp[1]) {
		    rm.idx2 = max(1, gap.start - current.len) : min(rm.tmp[count] + current.len, nrow(norm.D))
	    	} else {
		    rm.idx2 = c(rm.idx2, max(1, gap.start - current.len) : min(rm.tmp[count] + current.len, nrow(norm.D)))
	    	}
	    	gap.start = rm.tmp[count + 1]
	    	current.len = 1
	    }
	    count = count + 1
    	}
    } else {
	if (singleBAM) {
	    rm.idx2 = unique(c(which(norm.D$N > 0.5), which(norm.D$Outliers > window / 20), which(norm.D$Mean>4)))
	} else {
	    rm.idx2 = unique(c(which(norm.D$N > 0.5), which(norm.D$Outliers > window / 20), which(norm.D$GOutliers > window / 20), which(norm.D$Mean>8), which(norm.D$GMean>4)))
	}
    }
  }
}
cn.D = cn.D[-rm.idx,]
    if (norm.all) {
	weight = weight[-rm.idx]
	if (sum(is.nan(weight)) > 0) {
	    cn.lm1 = lm(cn.D$diff~cn.D$GC, subset=-which(is.nan(weight)), weights=weight)
	} else {
	    cn.lm1 = lm(cn.D$diff~cn.D$GC, weights=weight)
	}
	cn.D$diff = cn.lm1$residuals
	if (!singleBAM) {
		if (noLogWeight) {
		    if (sum(is.nan(weight)) > 0) {
		    	cn.lm2 = lm(cn.D$Log~cn.D$GC, subset=-which(is.nan(weight)))
		    } else {
			cn.lm2 = lm(cn.D$Log~cn.D$GC)
		    }
		} else {
		    if (sum(is.nan(weight)) > 0) {
		    	cn.lm2 = lm(cn.D$Log~cn.D$GC, subset=-which(is.nan(weight)), weights=weight)
		    } else {
		    	cn.lm2 = lm(cn.D$Log~cn.D$GC, weights=weight)
		    }
		}
	 	cn.D$Log = cn.lm2$residuals
	}
    } else {
	gc = norm.D$GC
	if (singleBAM) {
	    cn.lm1 = lm((norm.D$Mean)~gc, subset=-unique(c(rm.idx2, which(is.nan(weight)))), weights=weight)
	} else {
	    cn.lm1 = lm((norm.D$Mean-norm.D$GMean)~gc, subset=-unique(c(rm.idx2, which(is.nan(weight)))), weights=weight)
	}
	pre.tmp = data.frame(gc = cn.D$GC)
 	cn.D$diff = cn.D$diff - predict(cn.lm1, pre.tmp)
	if (!singleBAM) {
	    if (noLogWeight) {
 		cn.lm2 = lm((norm.D$Log)~gc, subset=-unique(c(rm.idx2, which(is.nan(weight)))))
	    } else {
		cn.lm2 = lm((norm.D$Log)~gc, subset=-unique(c(rm.idx2, which(is.nan(weight)))), weights=weight)
	    }
 	    cn.D$Log = cn.D$Log - predict(cn.lm2, pre.tmp)
	}
	rm(pre.tmp)
    }
rm(cn.lm1)
if (!singleBAM) rm(cn.lm2)
if (!norm.all) rm(norm.D)
gc(T)
paste("Finishing correcting GC content for difference:", date())
    num.test = 0
    for (i in 1 : numChr) {
	num.mark = sum(cn.D$Chr==i)
	num.test = num.test + num.mark^3/6 - num.mark^2/2 + num.mark/3
    }
    p.thresh = 0.05/num.test
if (singleBAM) {
    file.prefix = paste("Result/",sample,single, "_Single", d.appendix,"_CONSERTING_", sep="")
} else {
    file.prefix = paste("Result/",sample,d.appendix, "_CONSERTING_", sep="")
}
if (debug) file.prefix = paste(file.prefix, "Debug_", sep="") 
if (is.alter) {
	file.prefix = paste("Result/",sample,d.appendix,D.alter,"_CONSERTING_", sep="")
}
if (!CREST) {
	file.prefix = paste(file.prefix, "NoCREST_", sep="")
}
if (mapability) {
	file.prefix = paste(file.prefix, "Mapability_", g.appendix,window, sep="")
} else {
	file.prefix = paste(file.prefix, g.appendix,window, sep="")
}    
file.name = paste(file.prefix, ".txt",sep="")
if (!merge.diff) file.name = paste(file.prefix, "_raw.txt",sep="")
if (CREST) {
    bp.count=array(0, 24)
    bp.orig = bp
}
file.final=""
    if (CREST) {
      if (singleBAM) {
	if (mapability) {
	    file.done = paste("Result/doneSingle", single, "-map.lst", sep="")
	    file.final = paste("Result/CRESTSingle", single, "-map_final_report.txt", sep="")
	    file.tmp = paste("Result/CRESTSingle", single, "-map_tmpreport.txt", sep="")
	    file.tmp2 = paste("Result/CRESTSingle", single, "-map_tmp.txt", sep="")
	    if (is.alter) {
		file.done = paste("Result/doneSingle", single, "-map", D.alter, ".lst", sep="")
		file.final = paste("Result/CRESTSingle", single, "-map_final_report", D.alter, ".txt", sep="")
		file.tmp = paste("Result/CRESTSingle", single, "-map_tmpreport", D.alter, ".txt", sep="")
		file.tmp2 = paste("Result/CRESTSingle", single, "-map_tmp", D.alter, ".txt", sep="")
	    }
	} else {
	    file.done = paste("Result/doneSingle", single, ".lst", sep="")
	    file.final = paste("Result/CRESTSingle", single, "_final_report.txt",sep="")
	    file.tmp = paste("Result/CRESTSingle", single, "_tmpreport.txt", sep="")
	    file.tmp2 = paste("Result/CRESTSingle",single, "_tmp.txt", sep="")
	    if (is.alter) {
		file.done = paste("Result/doneSingle", single, D.alter, ".lst", sep="")
		file.final = paste("Result/CRESTSingle", single, "_final_report", D.alter, ".txt", sep="")
		file.tmp = paste("Result/CRESTSingle", single, "_tmpreport", D.alter, ".txt", sep="")
		file.tmp2 = paste("Result/CRESTSingle", single, "_tmp", D.alter, ".txt", sep="")
	    }
	}	
      } else {
	if (mapability) {
	    file.done = paste("Result/done-map", d.appendix, ".lst", sep="")
	    file.final = paste("Result/CREST-map_final_report", d.appendix, ".txt", sep="")
	    file.tmp = paste("Result/CREST-map_tmpreport", d.appendix,".txt", sep="")
	    file.tmp2 = paste("Result/CREST-map_tmp", d.appendix,".txt",sep="")
	    if (is.alter) {
		file.done = paste("Result/done-map", D.alter, d.appendix, ".lst", sep="")
		file.final = paste("Result/CREST-map_final_report", D.alter, d.appendix, ".txt", sep="")
		file.tmp = paste("Result/CREST-map_tmpreport", D.alter, d.appendix, ".txt", sep="")
		file.tmp2 = paste("Result/CREST-map_tmp", D.alter, d.appendix, ".txt", sep="")
	    }
	} else {
	    file.done = paste("Result/done", d.appendix,".lst",sep="")
	    file.final = paste("Result/CREST_final_report", d.appendix,".txt",sep="")
	    file.tmp = paste("Result/CREST_tmpreport", d.appendix,".txt",sep="")
	    file.tmp2 = paste("Result/CREST_tmp", d.appendix,".txt",sep="")
	    if (is.alter) {
		file.done = paste("Result/done", D.alter, d.appendix, ".lst", sep="")
		file.final = paste("Result/CREST_final_report", D.alter, d.appendix, ".txt", sep="")
		file.tmp = paste("Result/CREST_tmpreport", D.alter, d.appendix, ".txt", sep="")
		file.tmp2 = paste("Result/CREST_tmp", D.alter, d.appendix, ".txt", sep="")
	    }
	}
      }
    }

if (forced | (!file.exists(file.name))) {
    if (CREST) {
	cont = T
	done = array(0, dim=c(0,2))
	if ((!reDoSV) & file.exists(file.done)) {
	    done = read.table(file.done)
	    if (ncol(done) == 2) {
		done[,3] = done[,2] + 10000
		done[,2] = done[,2] - 10000
	    }
	} else {
	    done = array(0, dim = c(0, 3))
	    if (reDoSV & file.exists(file.final)) file.remove(file.final)
	}
	cycle = 1
	while (cont) {
	    if (file.exists(file.tmp)) file.remove(file.tmp)
	    if (cycle == 1) {
		if (file.exists(file.final)) {
		    if (file.exists(file.tmp2)) file.remove(file.tmp2)
		    system(paste("grep -v INV ", file.final, " | cut -f1-8 >", file.tmp2))
		    bp2 = try(read.table(file.tmp2))
		    if (class(bp2) !="try-error") {
			if (SV.toFilter) {
			    bp2.idx = which(as.integer(bp2[,4])*as.integer(bp2[,8]) > SV.filter)
			    if (nrow(bp.orig) > 0) {
				bp = rbind(bp.orig, as.matrix(bp2[bp2.idx,1:2]), as.matrix(bp2[bp2.idx,5:6]))
			    } else {
				bp = rbind(as.matrix(bp2[bp2.idx,1:2]), as.matrix(bp2[bp2.idx,5:6]))
			    }
			} else {
			    if (nrow(bp.orig) > 0) {
				bp = rbind(bp.orig, as.matrix(bp2[,1:2]), as.matrix(bp2[,5:6]))
			    } else {
				bp = rbind(as.matrix(bp2[,1:2]), as.matrix(bp2[,5:6]))
			    }
			}
		    }
		}
	    }
	    print(paste("Cycle:", cycle, "old softChr=", (softChr-1), date()))
	    if (debug) print(gc(T))
	    softChr = 1
	    for (chr in 1:numChr) {
		chr.idx = which(cn.D$Chr == chr)
		if (chr < 23) {
		    bp.chr = sort(unique(as.integer(bp[which(bp[,1]==chr),2])))
		}
		if (chr == 23) {
		    bp.chr = sort(unique(as.integer(bp[which(bp[,1]=="X"),2])))
		}
		if (chr == 24) {
		    bp.chr = sort(unique(as.integer(bp[which(bp[,1]=="Y"),2])))
		}
		bp.count[chr] = length(bp.chr)
		if (bp.count[chr] > 0) {
		    cn.D$SoftChr[chr.idx] = softChr + apply(cn.D[chr.idx,], 1, help.fun)
		    softChr = max(cn.D$SoftChr[chr.idx]) + 1
		} else {
		    cn.D$SoftChr[chr.idx] = softChr
		    softChr = softChr + 1
		}
		print(paste("Chromosome", chr, "Number of softChr", (softChr - 1), date()))
	    }
	    print(paste("new softChr=", (softChr-1)))


	
	    for (z in 1:(softChr-1)) {
		print(paste("SoftChr",z,":     ",sum(cn.D$SoftChr == z), "    ", date()))
		if (debug) print(gc(T))
		if (sum(cn.D$SoftChr == z) == 0) next
		if (singleBAM) {
		    seg.chr = fun.chr.germline(z, p.thresh=p.thresh)
		} else {
		    seg.chr = fun.chr(z, p.thresh=p.thresh)
		}
		if (z ==1) {
		    seg.final = seg.chr
		} else {
		    if (exists("seg.final")) {
			seg.final = rbind(seg.final, seg.chr)
		    } else {
			seg.final = seg.chr
		    }
		}
	    }
	    print(names(seg.final))
	    seg.tmp = seg.final
	    rm(seg.final)
	    for (z in 1:numChr) {
		seg.chr = seg.tmp[which(seg.tmp$chrom==z),]
		seg.diff = abs(seg.chr$seg.mean[-nrow(seg.chr)] - seg.chr$seg.mean[-1])
		seg.diff.id = which(seg.diff == min(seg.diff))[1]
		while (min(seg.diff) < thresh.diff) {
	 	    seg.chr$seg.mean[seg.diff.id] = (seg.chr$seg.mean[seg.diff.id] * seg.chr$num.mark[seg.diff.id] + seg.chr$seg.mean[seg.diff.id+1] * seg.chr$num.mark[seg.diff.id+1])/(seg.chr$num.mark[seg.diff.id] + seg.chr$num.mark[seg.diff.id+1])
		    if (!singleBAM) {
			seg.chr$GMean[seg.diff.id] = (seg.chr$GMean[seg.diff.id] * seg.chr$num.mark[seg.diff.id] + seg.chr$GMean[seg.diff.id+1] * seg.chr$num.mark[seg.diff.id+1])/(seg.chr$num.mark[seg.diff.id] + seg.chr$num.mark[seg.diff.id+1])
	 		seg.chr$DMean[seg.diff.id] = (seg.chr$DMean[seg.diff.id] * seg.chr$num.mark[seg.diff.id] + seg.chr$DMean[seg.diff.id+1] * seg.chr$num.mark[seg.diff.id+1])/(seg.chr$num.mark[seg.diff.id] + seg.chr$num.mark[seg.diff.id+1])
			seg.chr$LogRatio[seg.diff.id] = (seg.chr$LogRatio[seg.diff.id] * seg.chr$num.mark[seg.diff.id] + seg.chr$LogRatio[seg.diff.id+1] * seg.chr$num.mark[seg.diff.id+1])/(seg.chr$num.mark[seg.diff.id] + seg.chr$num.mark[seg.diff.id+1])
		    }
		    seg.chr$num.mark[seg.diff.id] = seg.chr$num.mark[seg.diff.id] + seg.chr$num.mark[seg.diff.id+1]
		    seg.chr$loc.end[seg.diff.id] = seg.chr$loc.end[seg.diff.id + 1]
		    seg.chr = seg.chr[-(seg.diff.id + 1),]
		    seg.diff = seg.diff[-seg.diff.id]
		    if (seg.diff.id > 1)
			seg.diff[seg.diff.id-1] = abs(seg.chr$seg.mean[seg.diff.id] - seg.chr$seg.mean[seg.diff.id-1])
			if (seg.diff.id <= length(seg.diff))
			    seg.diff[seg.diff.id] = abs(seg.chr$seg.mean[seg.diff.id+1] - seg.chr$seg.mean[seg.diff.id])
			seg.diff.id = which(seg.diff == min(seg.diff))[1]
		}
		if (!singleBAM) {
		    seg.diff = abs(seg.chr$LogRatio[-nrow(seg.chr)] - seg.chr$LogRatio[-1])
		    seg.diff.id = which(seg.diff == min(seg.diff))[1]
		    while (min(seg.diff) < logthresh.diff) {
			seg.chr$seg.mean[seg.diff.id] = (seg.chr$seg.mean[seg.diff.id] * seg.chr$num.mark[seg.diff.id] + seg.chr$seg.mean[seg.diff.id+1] * seg.chr$num.mark[seg.diff.id+1])/(seg.chr$num.mark[seg.diff.id] + seg.chr$num.mark[seg.diff.id+1])
			seg.chr$GMean[seg.diff.id] = (seg.chr$GMean[seg.diff.id] * seg.chr$num.mark[seg.diff.id] + seg.chr$GMean[seg.diff.id+1] * seg.chr$num.mark[seg.diff.id+1])/(seg.chr$num.mark[seg.diff.id] + seg.chr$num.mark[seg.diff.id+1])
			seg.chr$DMean[seg.diff.id] = (seg.chr$DMean[seg.diff.id] * seg.chr$num.mark[seg.diff.id] + seg.chr$DMean[seg.diff.id+1] * seg.chr$num.mark[seg.diff.id+1])/(seg.chr$num.mark[seg.diff.id] + seg.chr$num.mark[seg.diff.id+1])
			seg.chr$LogRatio[seg.diff.id] = (seg.chr$LogRatio[seg.diff.id] * seg.chr$num.mark[seg.diff.id] + seg.chr$LogRatio[seg.diff.id+1] * seg.chr$num.mark[seg.diff.id+1])/(seg.chr$num.mark[seg.diff.id] + seg.chr$num.mark[seg.diff.id+1])
			seg.chr$num.mark[seg.diff.id] = seg.chr$num.mark[seg.diff.id] + seg.chr$num.mark[seg.diff.id+1]
			seg.chr$loc.end[seg.diff.id] = seg.chr$loc.end[seg.diff.id + 1]
			seg.chr = seg.chr[-(seg.diff.id + 1),]
			seg.diff = seg.diff[-seg.diff.id]
			if (seg.diff.id > 1)
			    seg.diff[seg.diff.id-1] = abs(seg.chr$LogRatio[seg.diff.id] - seg.chr$LogRatio[seg.diff.id-1])
			    if (seg.diff.id <= length(seg.diff))
			    	seg.diff[seg.diff.id] = abs(seg.chr$LogRatio[seg.diff.id+1] - seg.chr$LogRatio[seg.diff.id])
			    seg.diff.id = which(seg.diff == min(seg.diff))[1]
			
		    }
		}

		seg.chr$length.ratio = seg.chr$num.mark * 100 / (seg.chr$loc.end - seg.chr$loc.start + 1)
		id = which(seg.chr$length.ratio < 0.9)
		mark.chr = cn.D[which(cn.D$Chr == z),]
		if (length(id) > 0) {
		    for (i in 1: length(id)) {
		    	if (singleBAM) {
		    	    if (abs(seg.chr$seg.mean[id[length(id) + 1 - i]]) < thresh.diff) next
		    	} else {
		    	    if (abs(seg.chr$LogRatio[id[length(id) + 1 - i]]) < logthresh.diff | abs(seg.chr$seg.mean[id[length(id) + 1 - i]]) < thresh.diff) next
		    	}
		    	idx1 = min(which(mark.chr$ChrPos > seg.chr$loc.start[id[length(id) + 1 - i]]))
		    	idx2 = min(which(mark.chr$ChrPos > seg.chr$loc.end[id[length(id) + 1 - i]])) - 1
		    	if (idx2 > nrow(mark.chr)) idx2 = nrow(mark.chr)
		    	tmp = mark.chr$ChrPos[idx1:idx2]
		    	tmp.diff = tmp[-1] - tmp[-length(tmp)]
		    	idx = which(tmp.diff==max(tmp.diff))[1]
		    	if (idx / length(tmp) <= 0.05 | idx / length(tmp) >= 0.95) {
			    seg.chr = rbind(seg.chr, seg.chr[1,])
			    if (id[length(id) + 1 - i] < nrow(seg.chr)) {
			    	seg.chr[(id[length(id) + 1 - i]+1):nrow(seg.chr),] = seg.chr[(id[length(id) + 1 - i]):(nrow(seg.chr)-1),]
			    }
			    seg.chr$loc.start[id[length(id) + 1 - i]+1] = tmp[idx+1] - 49
			    seg.chr$num.mark[id[length(id) + 1 - i]+1] = length(tmp) - idx
			    seg.chr$loc.end[id[length(id) + 1 - i]] = tmp[idx] + 50
			    seg.chr$num.mark[id[length(id) + 1 - i]] = idx
		    	}
		    }
		    seg.chr$length.ratio = seg.chr$num.mark * 100 / (seg.chr$loc.end - seg.chr$loc.start + 1)
		}
		if (z == 1) {
		    seg.final = seg.chr
		} else {
		    if (exists("seg.final")) {
		    	seg.final = rbind(seg.final, seg.chr)
		    } else {
			seg.final = seg.chr
		    }
		}
		if (nrow(seg.chr) > 1) {
		    done.init = nrow(done)
		    for (i in 2:nrow(seg.chr)) {
			region = findRegion(seg.chr$chrom[i], seg.chr$loc.start[i])
			if (region[1] <= region[2] & region[1] > 0) {
			    if (file.exists(paste(file.crest, ".predSV.txt", sep=""))) file.remove(paste(file.crest, ".predSV.txt", sep=""))
			    cmd = ""
			    if (seg.chr$chrom[i] < 23) {
				cmd = (paste(crest.cmd, seg.chr$chrom[i],":",region[1],"-",region[2],sep=""))
			    }
			    if (seg.chr$chrom[i] == 23) {
				cmd = (paste(crest.cmd,"X:",region[1],"-",region[2],sep=""))
			    }
			    if (seg.chr$chrom[i] == 24) {
				cmd = (paste(crest.cmd,"Y:",region[1],"-",region[2],sep=""))
			    }
			    print(cmd)
			    print(date())
			    if (system(cmd) != 0) {
				print("CRESTError!")
				next
			    }
			    if (file.exists(paste(file.crest, ".predSV.txt", sep=""))) system(paste("grep -v SClipA ", file.crest, ".predSV.txt >> ", file.tmp, sep=""))
			    done = rbind(done, c(seg.chr$chrom[i], seg.chr$loc.start[i] - 10000, seg.chr$loc.start[i] + 10000))
			    if ((nrow(done) - done.init) %% 10 == 0) write.table(done, file.done, col.names=FALSE,row.names=FALSE,sep="\t",quote=FALSE)
			} else {
			    next
			}
		    }
		    if ((nrow(done) - done.init) %% 10 > 0) write.table(done, file.done, col.names=FALSE,row.names=FALSE,sep="\t",quote=FALSE)
		}
	    }
	    cont=F
	    if (file.exists(file.tmp)) {
		system(paste("cat ", file.tmp, " >>", file.final))
		if (file.exists(file.tmp2))
		    file.remove(file.tmp2)
		system(paste("grep -v INV ", file.tmp, " | cut -f1-8 > ", file.tmp2, sep=""))
		bp2 = try(read.table(file.tmp2))
		if (class(bp2) !="try-error") {
		    if (SV.toFilter) {
			bp2.idx = which(as.integer(bp2[,4]) * as.integer(bp2[,8]) >SV.filter)
			bp2 = bp2[bp2.idx,]
		    }
		    bp = rbind(bp, as.matrix(bp2[,1:2]), as.matrix(bp2[,5:6]))
		    for (chr in 1:24) {
			if (chr < 23) {
			    bp.chr = unique(as.integer(bp[which(bp[,1]==chr),2]))
			}
			if (chr == 23) {
			    bp.chr = unique(as.integer(bp[which(bp[,1]=="X"),2]))
			}
			if (chr == 24) {
			    bp.chr = unique(as.integer(bp[which(bp[,1]=="Y"),2]))
			}
			if (length(bp.chr) > bp.count[chr]) {
			    cont = T
			    print(paste("Chromosome", chr, "Added BP:", (length(bp.chr) - bp.count[chr])))
			}
		    }
		}
	    }
	    cycle = cycle + 1
	}
    } else {
	for (i in 1:numChr){
	    print(paste("Chr",i,":",date()))
	    if (debug) print(gc(T))
	    if (sum(cn.D$SoftChr == i) == 0) next
	    if (singleBAM)  {
	        seg.chr = fun.chr.germline(i, p.thresh=p.thresh)
	    } else {
	        seg.chr = fun.chr(i, p.thresh=p.thresh)
	    }
	    if (i ==1) {
		seg.final = seg.chr
	    } else {
		if (exists("seg.final")) {
		    seg.final = rbind(seg.final, seg.chr)
		} else {
		    seg.final = seg.chr
		}
	    }
	}
    }
    seg.final[,-(1:4)] = round(seg.final[,-(1:4)] * 1000) / 1000
    print(names(seg.final))
    write.table(seg.final, file.name, col.names=TRUE,row.names=FALSE,sep="\t",quote=FALSE)

    if (!singleBAM) {
    	id.Y = which(seg.final$chrom==24)
	if (length(id.Y) > 0) {
    	    if (sum(seg.final$num.mark[id.Y] * seg.final$GMean[id.Y])/sum(seg.final$num.mark[id.Y]) > 0.2) Male = T
	}
    }

}
gc(T)

if (quality.merge) {
    if (plotAI) {
	if (Male) {
	    system(paste("java -cp ../code CNVQualityMerge -c1", sv.file, "-seg", file.name, "-c2", file.final, "-ai", ai.file, "-tm", tm.thresh, "-male"))
	} else {
	    system(paste("java -cp ../code CNVQualityMerge -c1", sv.file, "-seg", file.name, "-c2", file.final, "-ai", ai.file, "-tm", tm.thresh))
	}
    } else {
	if (Male) {
	    system(paste("java -cp ../code CNVQualityMerge -c1", sv.file, "-seg", file.name, "-c2", file.final, "-tm", tm.thresh, "-male"))
	} else {
	    system(paste("java -cp ../code CNVQualityMerge -c1", sv.file, "-seg", file.name, "-c2", file.final, "-tm", tm.thresh))
	}
    }
    file.name = paste(file.name, ".QualityMerge", sep="")
}
seg.final = read.table(file.name, header=T)
names(seg.final)
paste("Finishing building tree:", date())
gc(T)
file.name = paste(file.prefix,".png",sep="")
if (!merge.diff) file.name = paste(file.prefix,"_raw.png",sep="")
if (draw) {
  if (forced | toRedraw | (!file.exists(file.name))) {
    png(file.name,width=8000,height=4500)
    cols = c("lightgrey", "darkgrey")
    col.idx = 2
    layout(matrix(c(1,1,1,1,2:25), 7,4, byrow=T))
    idx = which(cn.D$Chr == numChr)
    plot(cn.D$Position[idx], cn.D$diff[idx],pch=".",col=cols[col.idx], xlab = "Position", ylab = "GC-corrected relative difference", xlim=c(0, cn.orig$Position[nrow(cn.orig)]), ylim=c(-1, 2), cex.lab=4, cex.main=4, cex.axis=3, main="")
    for (i in 1 : (numChr - 1)) {
    	col.idx = 3 - col.idx
	idx = which(cn.D$Chr == i)
    	points(cn.D$Position[idx], cn.D$diff[idx],pch=".",col=cols[col.idx])
    }
    for(s in 1:nrow(seg.final)){
        if (abs(seg.final$seg.mean[s]) > 0.25) {
	     lines(offset[seg.final$chrom[s]] + c(seg.final$loc.start[s],seg.final$loc.end[s]), rep(seg.final$seg.mean[s], 2), col = "red", lwd = 8)
        } else {
	     lines(offset[seg.final$chrom[s]] + c(seg.final$loc.start[s],seg.final$loc.end[s]), rep(seg.final$seg.mean[s], 2), col = "black", lwd = 8)
        }
    }
    if (is.alter) {
	mtext(paste("CONSERTING for", sample, D.alter, ", window size = ", window, sep=" "), outer=T, cex=10, line=-16)
    } else {
	mtext(paste("CONSERTING for", sample, ", window size = ", window, sep=" "), outer=T, cex=10, line=-16)
    }
    col.idx = 2
    pos = 1
    for (i in 1:numChr) {
	ylim = c(-1, 1.5)
       idx = which(cn.D$Chr == i)
	cbs.idx = which(seg.final$chrom == i)
	title.main = paste("Chromosome", i, sep=" ")
	if (i == 23) title.main = "Chromosome X"
	if (i == 24) title.main = "Chromosome Y"
	plot((cn.D$ChrPos[idx]), cn.D$diff[idx],pch=".",col="grey", xlab = "Position", ylab = " ", ylim=ylim, cex.lab=4, cex.main=4, cex.axis=3,  main=title.main)
    	for (j in 1 : length(cbs.idx)) {
	    draw.idx = (round(seg.final$loc.start[cbs.idx[j]]/10000):round(seg.final$loc.end[cbs.idx[j]]/10000))*10000
	    if (!singleBAM) {
	    	if (seg.final$LogRatio[cbs.idx[j]] > 0) {
		    lines(draw.idx,array(seg.final$LogRatio[cbs.idx[j]], length(draw.idx))/5, col = "green", type="h")
	    	} else {
		    lines(draw.idx,array(seg.final$LogRatio[cbs.idx[j]], length(draw.idx))/5, col = "darkgreen", type="h")
	    	}
	    }
           if (abs(seg.final$seg.mean[cbs.idx[j]]) > 0.25) {
               lines(c(seg.final$loc.start[cbs.idx[j]],seg.final$loc.end[cbs.idx[j]]),rep(seg.final$seg.mean[cbs.idx[j]], 2), col = "red", lwd=8)
           } else {
               lines(c(seg.final$loc.start[cbs.idx[j]],seg.final$loc.end[cbs.idx[j]]),rep(seg.final$seg.mean[cbs.idx[j]], 2), col = "black", lwd=8)
           }
       }
	print(paste(i, ", Number of segments: ", length(cbs.idx), ", starting pos: ", cbs.idx[1], sep=""))
	cn.idx = which(cn.orig$N[(offset[i]/window+1) : (offset[i+1]/window)] > 0)
    	lines((cn.orig$Position[(offset[i]/window+1) : (offset[i+1]/window)][cn.idx]) -offset[i], array(ylim[1], length(cn.idx)), type="h", col="white", lwd=1)
    	lines((cn.orig$Position[(offset[i]/window+1) : (offset[i+1]/window)][cn.idx]) -offset[i], array(ylim[2], length(cn.idx)), type="h", col="white", lwd=1)
    	lines((cn.orig$Position[(offset[i]/window+1) : (offset[i+1]/window)][cn.idx]) -offset[i], cn.orig$N[((offset[i]/window+1) : (offset[i+1]/window))[cn.idx]]/10, type="h", col="blue", lwd=1)
	ai.offset = ylim[2] - (ylim[2]-ylim[1]) / 4
	ai.scale = (ylim[2] - ylim[1]) / 2
	if (plotAI) {
	    ai.idx = which(ai$Chromosome==i & ai$AI > 0.1)
	    if (i == 23) ai.idx = which(ai$Chromosome=="X" & ai$AI > 0.1)
    	    points(ai$Position[ai.idx], ai.offset + ai$AI[ai.idx] * ai.scale, pch=".", col="cyan")
	    ai.idx = which(ai$Chromosome==i & ai$AI > 0.4)
	    if (i == 23) ai.idx = which(ai$Chromosome=="X" & ai$AI > 0.4)
    	    points(ai$Position[ai.idx], ai.offset + ai$AI[ai.idx] * ai.scale, pch=".", col="darkblue")
	}
    }
    dev.off()
  }
}

paste("Job completed:", date())
gc(T)
proc.time()
